# keplar-panel-integration-api
API documentation using Swagger

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.1
- Generator version: 7.14.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import keplar_panel_integration_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import keplar_panel_integration_api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import keplar_panel_integration_api
from keplar_panel_integration_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost:3000
# See configuration.py for a list of all supported configuration parameters.
configuration = keplar_panel_integration_api.Configuration(
    host = "http://localhost:3000"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): bearerAuth
configuration = keplar_panel_integration_api.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
async with keplar_panel_integration_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = keplar_panel_integration_api.DefaultApi(api_client)

    try:
        await api_instance.api_auth_google_get()
    except ApiException as e:
        print("Exception when calling DefaultApi->api_auth_google_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:3000*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**api_auth_google_get**](docs/DefaultApi.md#api_auth_google_get) | **GET** /api/auth/google | 
*DefaultApi* | [**api_auth_google_redirect_get**](docs/DefaultApi.md#api_auth_google_redirect_get) | **GET** /api/auth/google/redirect | 
*DefaultApi* | [**api_call_messages_search_post**](docs/DefaultApi.md#api_call_messages_search_post) | **POST** /api/callMessages/search | Search conversation messages
*DefaultApi* | [**api_calls_call_id_get**](docs/DefaultApi.md#api_calls_call_id_get) | **GET** /api/calls/{callId} | Get call
*DefaultApi* | [**api_calls_call_id_messages_index_get**](docs/DefaultApi.md#api_calls_call_id_messages_index_get) | **GET** /api/calls/{callId}/messages/{index} | Get conversation message
*DefaultApi* | [**api_copilotkit_post**](docs/DefaultApi.md#api_copilotkit_post) | **POST** /api/copilotkit | 
*DefaultApi* | [**api_demos_create_demo_invite_post**](docs/DefaultApi.md#api_demos_create_demo_invite_post) | **POST** /api/demos/createDemoInvite | Create demo invite
*DefaultApi* | [**api_files_file_id_delete**](docs/DefaultApi.md#api_files_file_id_delete) | **DELETE** /api/files/{fileId} | Delete a file
*DefaultApi* | [**api_files_file_id_get**](docs/DefaultApi.md#api_files_file_id_get) | **GET** /api/files/{fileId} | Get file metadata
*DefaultApi* | [**api_files_file_id_signed_url_post**](docs/DefaultApi.md#api_files_file_id_signed_url_post) | **POST** /api/files/{fileId}/signed-url | Get a signed URL for file access
*DefaultApi* | [**api_files_post**](docs/DefaultApi.md#api_files_post) | **POST** /api/files/ | Upload a file
*DefaultApi* | [**api_invite_code_code_get**](docs/DefaultApi.md#api_invite_code_code_get) | **GET** /api/inviteCode/{code}/ | Get invite by code
*DefaultApi* | [**api_invite_code_code_participant_code_participant_code_get**](docs/DefaultApi.md#api_invite_code_code_participant_code_participant_code_get) | **GET** /api/inviteCode/{code}/participantCode/{participantCode} | Get participant invite by code and participant code
*DefaultApi* | [**api_invite_code_code_participant_code_participant_code_start_get**](docs/DefaultApi.md#api_invite_code_code_participant_code_participant_code_start_get) | **GET** /api/inviteCode/{code}/participantCode/{participantCode}/start | Start invite by code and participant code
*DefaultApi* | [**api_invite_code_code_participant_code_participant_code_test_post**](docs/DefaultApi.md#api_invite_code_code_participant_code_participant_code_test_post) | **POST** /api/inviteCode/{code}/participantCode/{participantCode}/test | Create test invite by code and participant code
*DefaultApi* | [**api_invite_code_code_participant_response_get**](docs/DefaultApi.md#api_invite_code_code_participant_response_get) | **GET** /api/inviteCode/{code}/participantResponse | Get invite response by invite code and participant code
*DefaultApi* | [**api_invite_code_code_remaining_responses_get**](docs/DefaultApi.md#api_invite_code_code_remaining_responses_get) | **GET** /api/inviteCode/{code}/remainingResponses | Get remaining responses count by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_call_metadata_get**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_call_metadata_get) | **GET** /api/inviteCode/{code}/responses/{responseId}/callMetadata | Get call metadata by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_create_new_response_post**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_create_new_response_post) | **POST** /api/inviteCode/{code}/responses/{responseId}/createNewResponse | Create invite response from existing response
*DefaultApi* | [**api_invite_code_code_responses_response_id_get**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_get) | **GET** /api/inviteCode/{code}/responses/{responseId} | Get invite response by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_put**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_put) | **PUT** /api/inviteCode/{code}/responses/{responseId} | Update invite response by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_start_call_get**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_start_call_get) | **GET** /api/inviteCode/{code}/responses/{responseId}/startCall | Start call by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_start_phone_call_post**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_start_phone_call_post) | **POST** /api/inviteCode/{code}/responses/{responseId}/startPhoneCall | Start phone call by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_transcript_insight_post**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_transcript_insight_post) | **POST** /api/inviteCode/{code}/responses/{responseId}/transcriptInsight | Create call metadata transcript insight by invite code
*DefaultApi* | [**api_invite_code_code_responses_response_id_update_call_put**](docs/DefaultApi.md#api_invite_code_code_responses_response_id_update_call_put) | **PUT** /api/inviteCode/{code}/responses/{responseId}/updateCall | Update call by invite code
*DefaultApi* | [**api_invite_code_code_start_get**](docs/DefaultApi.md#api_invite_code_code_start_get) | **GET** /api/inviteCode/{code}/start | Start invite by code
*DefaultApi* | [**api_invites_id_get**](docs/DefaultApi.md#api_invites_id_get) | **GET** /api/invites/{id} | Get invite
*DefaultApi* | [**api_invites_id_participant_invites_get**](docs/DefaultApi.md#api_invites_id_participant_invites_get) | **GET** /api/invites/{id}/participantInvites | Get participant invites
*DefaultApi* | [**api_invites_id_participant_invites_participant_id_get**](docs/DefaultApi.md#api_invites_id_participant_invites_participant_id_get) | **GET** /api/invites/{id}/participantInvites/{participantId} | Get participant invite
*DefaultApi* | [**api_invites_id_participant_invites_participant_id_put**](docs/DefaultApi.md#api_invites_id_participant_invites_participant_id_put) | **PUT** /api/invites/{id}/participantInvites/{participantId} | Update participant invite
*DefaultApi* | [**api_invites_id_participant_invites_post**](docs/DefaultApi.md#api_invites_id_participant_invites_post) | **POST** /api/invites/{id}/participantInvites | Create participant invite
*DefaultApi* | [**api_invites_id_participants_participant_id_call_metadata_get**](docs/DefaultApi.md#api_invites_id_participants_participant_id_call_metadata_get) | **GET** /api/invites/{id}/participants/{participantId}/callMetadata | Get call metadata by invite ID and participant ID
*DefaultApi* | [**api_invites_id_put**](docs/DefaultApi.md#api_invites_id_put) | **PUT** /api/invites/{id}/ | Update invite
*DefaultApi* | [**api_invites_id_responses_get**](docs/DefaultApi.md#api_invites_id_responses_get) | **GET** /api/invites/{id}/responses | Get invite responses
*DefaultApi* | [**api_invites_id_responses_post**](docs/DefaultApi.md#api_invites_id_responses_post) | **POST** /api/invites/{id}/responses | Create invite response
*DefaultApi* | [**api_invites_id_responses_response_id_call_metadata_get**](docs/DefaultApi.md#api_invites_id_responses_response_id_call_metadata_get) | **GET** /api/invites/{id}/responses/{responseId}/callMetadata | Get call metadata by invite ID and response ID
*DefaultApi* | [**api_invites_id_responses_response_id_get**](docs/DefaultApi.md#api_invites_id_responses_response_id_get) | **GET** /api/invites/{id}/responses/{responseId} | Get invite response
*DefaultApi* | [**api_invites_id_responses_response_id_put**](docs/DefaultApi.md#api_invites_id_responses_response_id_put) | **PUT** /api/invites/{id}/responses/{responseId} | Update invite response
*DefaultApi* | [**api_invites_post**](docs/DefaultApi.md#api_invites_post) | **POST** /api/invites/ | Create invite
*DefaultApi* | [**api_projects_draft_get**](docs/DefaultApi.md#api_projects_draft_get) | **GET** /api/projects/draft | Get draft project
*DefaultApi* | [**api_projects_get**](docs/DefaultApi.md#api_projects_get) | **GET** /api/projects/ | Get projects
*DefaultApi* | [**api_projects_post**](docs/DefaultApi.md#api_projects_post) | **POST** /api/projects/ | Create project
*DefaultApi* | [**api_projects_project_id_analysis_post**](docs/DefaultApi.md#api_projects_project_id_analysis_post) | **POST** /api/projects/{projectId}/analysis | Create project analysis
*DefaultApi* | [**api_projects_project_id_delete_post**](docs/DefaultApi.md#api_projects_project_id_delete_post) | **POST** /api/projects/{projectId}/delete | Delete or archive project
*DefaultApi* | [**api_projects_project_id_files_file_id_delete**](docs/DefaultApi.md#api_projects_project_id_files_file_id_delete) | **DELETE** /api/projects/{projectId}/files/{fileId} | Remove a file from a project
*DefaultApi* | [**api_projects_project_id_files_file_id_put**](docs/DefaultApi.md#api_projects_project_id_files_file_id_put) | **PUT** /api/projects/{projectId}/files/{fileId} | Update project file metadata
*DefaultApi* | [**api_projects_project_id_files_get**](docs/DefaultApi.md#api_projects_project_id_files_get) | **GET** /api/projects/{projectId}/files | Get files for a project
*DefaultApi* | [**api_projects_project_id_files_post**](docs/DefaultApi.md#api_projects_project_id_files_post) | **POST** /api/projects/{projectId}/files | Add an existing file to a project
*DefaultApi* | [**api_projects_project_id_get**](docs/DefaultApi.md#api_projects_project_id_get) | **GET** /api/projects/{projectId} | Get project
*DefaultApi* | [**api_projects_project_id_launch_post**](docs/DefaultApi.md#api_projects_project_id_launch_post) | **POST** /api/projects/{projectId}/launch | Launch project
*DefaultApi* | [**api_projects_project_id_put**](docs/DefaultApi.md#api_projects_project_id_put) | **PUT** /api/projects/{projectId} | Update project
*DefaultApi* | [**api_projects_project_id_responses_get**](docs/DefaultApi.md#api_projects_project_id_responses_get) | **GET** /api/projects/{projectId}/responses | Get project responses
*DefaultApi* | [**api_projects_project_id_search_transcripts_post**](docs/DefaultApi.md#api_projects_project_id_search_transcripts_post) | **POST** /api/projects/{projectId}/searchTranscripts | Search project transcripts
*DefaultApi* | [**api_threads_get**](docs/DefaultApi.md#api_threads_get) | **GET** /api/threads/ | Get threads
*DefaultApi* | [**api_threads_thread_id_files_get**](docs/DefaultApi.md#api_threads_thread_id_files_get) | **GET** /api/threads/{threadId}/files | Get thread files
*DefaultApi* | [**api_threads_thread_id_post**](docs/DefaultApi.md#api_threads_thread_id_post) | **POST** /api/threads/{threadId} | Upsert thread
*DefaultApi* | [**api_users_id_get**](docs/DefaultApi.md#api_users_id_get) | **GET** /api/users/{id} | Get user
*DefaultApi* | [**api_vapi_webhook_post**](docs/DefaultApi.md#api_vapi_webhook_post) | **POST** /api/vapi/webhook | 


## Documentation For Models

 - [ApiCallMessagesSearchPost200ResponseInner](docs/ApiCallMessagesSearchPost200ResponseInner.md)
 - [ApiDemosCreateDemoInvitePostRequest](docs/ApiDemosCreateDemoInvitePostRequest.md)
 - [ApiFilesFileIdSignedUrlPost200Response](docs/ApiFilesFileIdSignedUrlPost200Response.md)
 - [ApiFilesFileIdSignedUrlPostRequest](docs/ApiFilesFileIdSignedUrlPostRequest.md)
 - [ApiFilesFileIdSignedUrlPostRequestAction](docs/ApiFilesFileIdSignedUrlPostRequestAction.md)
 - [ApiInviteCodeCodeResponsesResponseIdPut404Response](docs/ApiInviteCodeCodeResponsesResponseIdPut404Response.md)
 - [ApiInviteCodeCodeResponsesResponseIdStartPhoneCallPostRequest](docs/ApiInviteCodeCodeResponsesResponseIdStartPhoneCallPostRequest.md)
 - [ApiInviteCodeCodeResponsesResponseIdUpdateCallPutRequest](docs/ApiInviteCodeCodeResponsesResponseIdUpdateCallPutRequest.md)
 - [ApiInviteCodeCodeResponsesResponseIdUpdateCallPutRequestCall](docs/ApiInviteCodeCodeResponsesResponseIdUpdateCallPutRequestCall.md)
 - [ApiInviteCodeCodeStartGet302Response](docs/ApiInviteCodeCodeStartGet302Response.md)
 - [ApiInviteCodeCodeStartGet302ResponseProjectConfig](docs/ApiInviteCodeCodeStartGet302ResponseProjectConfig.md)
 - [ApiInvitesIdParticipantInvitesParticipantIdPutRequest](docs/ApiInvitesIdParticipantInvitesParticipantIdPutRequest.md)
 - [ApiInvitesIdParticipantInvitesPostRequest](docs/ApiInvitesIdParticipantInvitesPostRequest.md)
 - [ApiInvitesIdParticipantInvitesPostRequestParticipant](docs/ApiInvitesIdParticipantInvitesPostRequestParticipant.md)
 - [ApiInvitesIdPutRequest](docs/ApiInvitesIdPutRequest.md)
 - [ApiInvitesIdResponsesGet200Response](docs/ApiInvitesIdResponsesGet200Response.md)
 - [ApiInvitesIdResponsesPostRequest](docs/ApiInvitesIdResponsesPostRequest.md)
 - [ApiInvitesIdResponsesResponseIdPutRequest](docs/ApiInvitesIdResponsesResponseIdPutRequest.md)
 - [ApiInvitesPostRequest](docs/ApiInvitesPostRequest.md)
 - [ApiProjectsGet200Response](docs/ApiProjectsGet200Response.md)
 - [ApiProjectsPostRequest](docs/ApiProjectsPostRequest.md)
 - [ApiProjectsPostRequestThreadAssetsInner](docs/ApiProjectsPostRequestThreadAssetsInner.md)
 - [ApiProjectsProjectIdFilesFileIdPutRequest](docs/ApiProjectsProjectIdFilesFileIdPutRequest.md)
 - [ApiProjectsProjectIdFilesGet200Response](docs/ApiProjectsProjectIdFilesGet200Response.md)
 - [ApiProjectsProjectIdFilesPostRequest](docs/ApiProjectsProjectIdFilesPostRequest.md)
 - [ApiProjectsProjectIdPutRequest](docs/ApiProjectsProjectIdPutRequest.md)
 - [ApiProjectsProjectIdSearchTranscriptsPostRequest](docs/ApiProjectsProjectIdSearchTranscriptsPostRequest.md)
 - [ApiThreadsGet200Response](docs/ApiThreadsGet200Response.md)
 - [ApiThreadsThreadIdFilesGet200Response](docs/ApiThreadsThreadIdFilesGet200Response.md)
 - [ApiThreadsThreadIdPostRequest](docs/ApiThreadsThreadIdPostRequest.md)
 - [BadRequestErrorResponse](docs/BadRequestErrorResponse.md)
 - [Call](docs/Call.md)
 - [CallEvent](docs/CallEvent.md)
 - [CallKind](docs/CallKind.md)
 - [CallMetadata](docs/CallMetadata.md)
 - [CallStatus](docs/CallStatus.md)
 - [ChatCompletionTool](docs/ChatCompletionTool.md)
 - [ChatCompletionToolFunction](docs/ChatCompletionToolFunction.md)
 - [ChatMessage](docs/ChatMessage.md)
 - [ChatMessageKind](docs/ChatMessageKind.md)
 - [ChatMessageRole](docs/ChatMessageRole.md)
 - [ChatSession](docs/ChatSession.md)
 - [Citation](docs/Citation.md)
 - [CodeInvite](docs/CodeInvite.md)
 - [CodeInviteResponse](docs/CodeInviteResponse.md)
 - [ConversationMessage](docs/ConversationMessage.md)
 - [ConversationMessageTopic](docs/ConversationMessageTopic.md)
 - [File](docs/File.md)
 - [FileMimeType](docs/FileMimeType.md)
 - [ForbiddenErrorResponse](docs/ForbiddenErrorResponse.md)
 - [GetParticipantInvitesResponse](docs/GetParticipantInvitesResponse.md)
 - [GetProjectResponsesResponse](docs/GetProjectResponsesResponse.md)
 - [InboundCallResponse](docs/InboundCallResponse.md)
 - [InternalServerErrorResponse](docs/InternalServerErrorResponse.md)
 - [Invite](docs/Invite.md)
 - [InviteConfig](docs/InviteConfig.md)
 - [InviteResponse](docs/InviteResponse.md)
 - [InviteResponseData](docs/InviteResponseData.md)
 - [InviteResponseKind](docs/InviteResponseKind.md)
 - [InviteResponseStatus](docs/InviteResponseStatus.md)
 - [InviteResponseUpdateEvent](docs/InviteResponseUpdateEvent.md)
 - [InviteStatus](docs/InviteStatus.md)
 - [InviteWithAnalytics](docs/InviteWithAnalytics.md)
 - [Moderator](docs/Moderator.md)
 - [ModeratorVendor](docs/ModeratorVendor.md)
 - [ModeratorVisibility](docs/ModeratorVisibility.md)
 - [NotFoundErrorResponse](docs/NotFoundErrorResponse.md)
 - [OpenAiModelConfig](docs/OpenAiModelConfig.md)
 - [Org](docs/Org.md)
 - [Participant](docs/Participant.md)
 - [ParticipantCreate](docs/ParticipantCreate.md)
 - [ParticipantInvite](docs/ParticipantInvite.md)
 - [ParticipantInviteConfig](docs/ParticipantInviteConfig.md)
 - [ParticipantInviteData](docs/ParticipantInviteData.md)
 - [PhoneCallStartResponse](docs/PhoneCallStartResponse.md)
 - [Project](docs/Project.md)
 - [ProjectAnalysis](docs/ProjectAnalysis.md)
 - [ProjectAudience](docs/ProjectAudience.md)
 - [ProjectConfig](docs/ProjectConfig.md)
 - [ProjectConversationConfig](docs/ProjectConversationConfig.md)
 - [ProjectFile](docs/ProjectFile.md)
 - [ProjectFileCategory](docs/ProjectFileCategory.md)
 - [ProjectFileMetadata](docs/ProjectFileMetadata.md)
 - [ProjectFilePublic](docs/ProjectFilePublic.md)
 - [ProjectFilePublicFile](docs/ProjectFilePublicFile.md)
 - [ProjectPanelQualification](docs/ProjectPanelQualification.md)
 - [ProjectPanelRespondentAttribute](docs/ProjectPanelRespondentAttribute.md)
 - [ProjectPanelSettings](docs/ProjectPanelSettings.md)
 - [ProjectScreenerQuestionChooseOne](docs/ProjectScreenerQuestionChooseOne.md)
 - [ProjectScreenerQuestionChooseOnePublic](docs/ProjectScreenerQuestionChooseOnePublic.md)
 - [ProjectScreenerQuestionResponse](docs/ProjectScreenerQuestionResponse.md)
 - [ProjectStatus](docs/ProjectStatus.md)
 - [ProjectSummaryWithAnalytics](docs/ProjectSummaryWithAnalytics.md)
 - [ProjectTemplateSettings](docs/ProjectTemplateSettings.md)
 - [ProjectWithAnalytics](docs/ProjectWithAnalytics.md)
 - [RemainingResponsesResponse](docs/RemainingResponsesResponse.md)
 - [RepDataConfigLegacy](docs/RepDataConfigLegacy.md)
 - [RepDataProjectLegacy](docs/RepDataProjectLegacy.md)
 - [RepDataStudyLegacy](docs/RepDataStudyLegacy.md)
 - [RepDataStudyLegacyQualificationsInner](docs/RepDataStudyLegacyQualificationsInner.md)
 - [RepDataSurveyLegacy](docs/RepDataSurveyLegacy.md)
 - [RepDataSurveyLegacyProject](docs/RepDataSurveyLegacyProject.md)
 - [RepDataSurveyStatusLegacy](docs/RepDataSurveyStatusLegacy.md)
 - [RepdataQualification](docs/RepdataQualification.md)
 - [RepdataQualificationAllowedOptionIdsInner](docs/RepdataQualificationAllowedOptionIdsInner.md)
 - [RepdataRespondentAttribute](docs/RepdataRespondentAttribute.md)
 - [RepdataSurvey](docs/RepdataSurvey.md)
 - [RepdataSurveyAttributes](docs/RepdataSurveyAttributes.md)
 - [RepdataSurveyRedirects](docs/RepdataSurveyRedirects.md)
 - [ResponseCallCompletedEvent](docs/ResponseCallCompletedEvent.md)
 - [ResponseCallFailedEvent](docs/ResponseCallFailedEvent.md)
 - [ResponseConsentEvent](docs/ResponseConsentEvent.md)
 - [ResponseOptOutEvent](docs/ResponseOptOutEvent.md)
 - [ResponseProcessingCompletedEvent](docs/ResponseProcessingCompletedEvent.md)
 - [ResponseProcessingFailedEvent](docs/ResponseProcessingFailedEvent.md)
 - [ResponseRedirectEvent](docs/ResponseRedirectEvent.md)
 - [ResponseStartCallEvent](docs/ResponseStartCallEvent.md)
 - [ResponseSubmitEmailEvent](docs/ResponseSubmitEmailEvent.md)
 - [ResponseSubmitScreenerEvent](docs/ResponseSubmitScreenerEvent.md)
 - [SearchProjectTranscriptsResponse](docs/SearchProjectTranscriptsResponse.md)
 - [TemplateConceptTest](docs/TemplateConceptTest.md)
 - [TemplateCustom](docs/TemplateCustom.md)
 - [TemplateInterview](docs/TemplateInterview.md)
 - [Thread](docs/Thread.md)
 - [ThreadCreateProjectStatus](docs/ThreadCreateProjectStatus.md)
 - [ThreadFile](docs/ThreadFile.md)
 - [ThreadKind](docs/ThreadKind.md)
 - [ThreadMetadata](docs/ThreadMetadata.md)
 - [Transcript](docs/Transcript.md)
 - [TranscriptMessage](docs/TranscriptMessage.md)
 - [TranscriptMessagesInner](docs/TranscriptMessagesInner.md)
 - [TranscriptQuality](docs/TranscriptQuality.md)
 - [UnauthorizedErrorResponse](docs/UnauthorizedErrorResponse.md)
 - [User](docs/User.md)
 - [UserAccountStatus](docs/UserAccountStatus.md)
 - [UserData](docs/UserData.md)
 - [UserProvider](docs/UserProvider.md)
 - [VapiAssistantConfig](docs/VapiAssistantConfig.md)
 - [VapiVoiceId](docs/VapiVoiceId.md)
 - [VapiVoiceVapiProvider](docs/VapiVoiceVapiProvider.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (JWT)


## Author




