# coding: utf-8

"""
    Fastify Template API

    API documentation using Swagger

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from keplar_panel_integration_api.models.rep_data_study_legacy_qualifications_inner import RepDataStudyLegacyQualificationsInner
from typing import Optional, Set
from typing_extensions import Self

class RepDataStudyLegacy(BaseModel):
    """
    RepDataStudyLegacy
    """ # noqa: E501
    name: StrictStr
    compensation: Union[StrictFloat, StrictInt]
    length_of_interview: Union[StrictFloat, StrictInt] = Field(alias="lengthOfInterview")
    incidence_rate: Union[StrictFloat, StrictInt] = Field(alias="incidenceRate")
    country_code: StrictStr = Field(alias="countryCode")
    language_code: StrictStr = Field(alias="languageCode")
    device_compatibility: List[StrictStr] = Field(alias="deviceCompatibility")
    min_age: Union[StrictFloat, StrictInt] = Field(alias="minAge")
    max_age: Union[StrictFloat, StrictInt] = Field(alias="maxAge")
    genders: List[StrictStr]
    qualifications: List[RepDataStudyLegacyQualificationsInner]
    __properties: ClassVar[List[str]] = ["name", "compensation", "lengthOfInterview", "incidenceRate", "countryCode", "languageCode", "deviceCompatibility", "minAge", "maxAge", "genders", "qualifications"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RepDataStudyLegacy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in qualifications (list)
        _items = []
        if self.qualifications:
            for _item_qualifications in self.qualifications:
                if _item_qualifications:
                    _items.append(_item_qualifications.to_dict())
            _dict['qualifications'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RepDataStudyLegacy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "compensation": obj.get("compensation"),
            "lengthOfInterview": obj.get("lengthOfInterview"),
            "incidenceRate": obj.get("incidenceRate"),
            "countryCode": obj.get("countryCode"),
            "languageCode": obj.get("languageCode"),
            "deviceCompatibility": obj.get("deviceCompatibility"),
            "minAge": obj.get("minAge"),
            "maxAge": obj.get("maxAge"),
            "genders": obj.get("genders"),
            "qualifications": [RepDataStudyLegacyQualificationsInner.from_dict(_item) for _item in obj["qualifications"]] if obj.get("qualifications") is not None else None
        })
        return _obj


