# coding: utf-8

"""
    Fastify Template API

    API documentation using Swagger

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from keplar_panel_integration_api.models.user_account_status import UserAccountStatus
from keplar_panel_integration_api.models.user_data import UserData
from keplar_panel_integration_api.models.user_provider import UserProvider
from typing import Optional, Set
from typing_extensions import Self

class User(BaseModel):
    """
    User
    """ # noqa: E501
    id: StrictStr
    seq: Union[StrictFloat, StrictInt]
    created_at: datetime = Field(alias="createdAt")
    updated_at: datetime = Field(alias="updatedAt")
    provider: UserProvider
    user_id: StrictStr = Field(alias="userId")
    email: StrictStr
    name: StrictStr
    account_status: UserAccountStatus = Field(alias="accountStatus")
    location: Optional[StrictStr] = None
    profile_image_url: Optional[StrictStr] = Field(default=None, alias="profileImageUrl")
    data: Optional[UserData] = None
    org_id: StrictStr = Field(alias="orgId")
    org: Optional[Org] = None
    projects: Optional[List[Project]] = None
    invites: Optional[List[Invite]] = None
    chat_sessions: Optional[List[ChatSession]] = Field(default=None, alias="chatSessions")
    moderators: Optional[List[Moderator]] = None
    uploaded_files: Optional[List[File]] = Field(default=None, alias="uploadedFiles")
    threads: Optional[List[Thread]] = None
    __properties: ClassVar[List[str]] = ["id", "seq", "createdAt", "updatedAt", "provider", "userId", "email", "name", "accountStatus", "location", "profileImageUrl", "data", "orgId", "org", "projects", "invites", "chatSessions", "moderators", "uploadedFiles", "threads"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict['data'] = self.data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of org
        if self.org:
            _dict['org'] = self.org.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in projects (list)
        _items = []
        if self.projects:
            for _item_projects in self.projects:
                if _item_projects:
                    _items.append(_item_projects.to_dict())
            _dict['projects'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invites (list)
        _items = []
        if self.invites:
            for _item_invites in self.invites:
                if _item_invites:
                    _items.append(_item_invites.to_dict())
            _dict['invites'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in chat_sessions (list)
        _items = []
        if self.chat_sessions:
            for _item_chat_sessions in self.chat_sessions:
                if _item_chat_sessions:
                    _items.append(_item_chat_sessions.to_dict())
            _dict['chatSessions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in moderators (list)
        _items = []
        if self.moderators:
            for _item_moderators in self.moderators:
                if _item_moderators:
                    _items.append(_item_moderators.to_dict())
            _dict['moderators'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in uploaded_files (list)
        _items = []
        if self.uploaded_files:
            for _item_uploaded_files in self.uploaded_files:
                if _item_uploaded_files:
                    _items.append(_item_uploaded_files.to_dict())
            _dict['uploadedFiles'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in threads (list)
        _items = []
        if self.threads:
            for _item_threads in self.threads:
                if _item_threads:
                    _items.append(_item_threads.to_dict())
            _dict['threads'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "seq": obj.get("seq"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "provider": obj.get("provider"),
            "userId": obj.get("userId"),
            "email": obj.get("email"),
            "name": obj.get("name"),
            "accountStatus": obj.get("accountStatus"),
            "location": obj.get("location"),
            "profileImageUrl": obj.get("profileImageUrl"),
            "data": UserData.from_dict(obj["data"]) if obj.get("data") is not None else None,
            "orgId": obj.get("orgId"),
            "org": Org.from_dict(obj["org"]) if obj.get("org") is not None else None,
            "projects": [Project.from_dict(_item) for _item in obj["projects"]] if obj.get("projects") is not None else None,
            "invites": [Invite.from_dict(_item) for _item in obj["invites"]] if obj.get("invites") is not None else None,
            "chatSessions": [ChatSession.from_dict(_item) for _item in obj["chatSessions"]] if obj.get("chatSessions") is not None else None,
            "moderators": [Moderator.from_dict(_item) for _item in obj["moderators"]] if obj.get("moderators") is not None else None,
            "uploadedFiles": [File.from_dict(_item) for _item in obj["uploadedFiles"]] if obj.get("uploadedFiles") is not None else None,
            "threads": [Thread.from_dict(_item) for _item in obj["threads"]] if obj.get("threads") is not None else None
        })
        return _obj

from keplar_panel_integration_api.models.chat_session import ChatSession
from keplar_panel_integration_api.models.file import File
from keplar_panel_integration_api.models.invite import Invite
from keplar_panel_integration_api.models.moderator import Moderator
from keplar_panel_integration_api.models.org import Org
from keplar_panel_integration_api.models.project import Project
from keplar_panel_integration_api.models.thread import Thread
# TODO: Rewrite to not use raise_errors
User.model_rebuild(raise_errors=False)

